<a id="mypy-boto3-waf-regional"></a>

# mypy-boto3-waf-regional

[![PyPI - mypy-boto3-waf-regional](https://img.shields.io/pypi/v/mypy-boto3-waf-regional.svg?color=blue)](https://pypi.org/project/mypy-boto3-waf-regional)
[![PyPI - Python Version](https://img.shields.io/pypi/pyversions/mypy-boto3-waf-regional.svg?color=blue)](https://pypi.org/project/mypy-boto3-waf-regional)
[![Docs](https://img.shields.io/readthedocs/mypy-boto3-builder.svg?color=blue)](https://mypy-boto3-builder.readthedocs.io/)
[![PyPI - Downloads](https://img.shields.io/pypi/dw/mypy-boto3-waf-regional?color=blue)](https://pypistats.org/packages/mypy-boto3-waf-regional)

![boto3.typed](https://github.com/vemel/mypy_boto3_builder/raw/master/logo.png)

Type annotations for
[boto3.WAFRegional 1.17.102](https://boto3.amazonaws.com/v1/documentation/api/1.17.102/reference/services/waf-regional.html#WAFRegional)
service compatible with [VSCode](https://code.visualstudio.com/),
[PyCharm](https://www.jetbrains.com/pycharm/),
[Emacs](https://www.gnu.org/software/emacs/),
[Sublime Text](https://www.sublimetext.com/),
[mypy](https://github.com/python/mypy),
[pyright](https://github.com/microsoft/pyright) and other tools.

Generated by
[mypy-boto3-buider 4.20.0](https://github.com/vemel/mypy_boto3_builder).

More information can be found on
[boto3-stubs](https://pypi.org/project/boto3-stubs/) page and in
[mypy-boto3-waf-regional docs](https://vemel.github.io/boto3_stubs_docs/mypy_boto3_waf_regional/)

See how it helps to find and fix potential bugs:

![boto3-stubs demo](https://github.com/vemel/mypy_boto3_builder/raw/master/demo.gif)

- [mypy-boto3-waf-regional](#mypy-boto3-waf-regional)
  - [How to install](#how-to-install)
  - [Usage](#usage)
    - [VSCode](#vscode)
    - [PyCharm](#pycharm)
    - [Other IDEs](#other-ides)
    - [mypy](#mypy)
    - [pyright](#pyright)
  - [Explicit type annotations](#explicit-type-annotations)
    - [Client annotations](#client-annotations)
    - [Literals](#literals)
    - [Typed dictionaries](#typed-dictionaries)
  - [Versioning](#versioning)
  - [Documentation](#documentation)
  - [Support and contributing](#support-and-contributing)

<a id="how-to-install"></a>

## How to install

Install `boto3-stubs` for `WAFRegional` service.

```bash
python -m pip install boto3-stubs[waf-regional]
```

<a id="usage"></a>

## Usage

<a id="vscode"></a>

### VSCode

- Install
  [Python extension](https://marketplace.visualstudio.com/items?itemName=ms-python.python)
- Install
  [Pylance extension](https://marketplace.visualstudio.com/items?itemName=ms-python.vscode-pylance)
- Set `Pylance` as your Python Language Server
- Install `boto-stubs[waf-regional]` in your environment:
  `python -m pip install 'boto3-stubs[waf-regional]'`

Both type checking and auto-complete should work for `WAFRegional` service. No
explicit type annotations required, write your `boto3` code as usual.

<a id="pycharm"></a>

### PyCharm

- Install `boto-stubs[waf-regional]` in your environment:
  `python -m pip install 'boto3-stubs[waf-regional]'`

Both type checking and auto-complete should work for `WAFRegional` service. No
explicit type annotations required, write your `boto3` code as usual.
Auto-complete can be slow on big projects or if you have a lot of installed
`boto3-stubs` submodules.

<a id="other-ides"></a>

### Other IDEs

Not tested, but as long as your IDE support `mypy` or `pyright`, everything
should work.

<a id="mypy"></a>

### mypy

- Install `mypy`: `python -m pip install mypy`
- Install `boto-stubs[waf-regional]` in your environment:
  `python -m pip install 'boto3-stubs[waf-regional]'`
- Run `mypy` as usual

Type checking should work for `WAFRegional` service. No explicit type
annotations required, write your `boto3` code as usual.

<a id="pyright"></a>

### pyright

- Install `pyright`: `yarn global add pyright`
- Install `boto-stubs[waf-regional]` in your environment:
  `python -m pip install 'boto3-stubs[waf-regional]'`
- Optionally, you can install `boto3-stubs` to `typings` folder.

Type checking should work for `WAFRegional` service. No explicit type
annotations required, write your `boto3` code as usual.

<a id="explicit-type-annotations"></a>

## Explicit type annotations

<a id="client-annotations"></a>

### Client annotations

`WAFRegionalClient` provides annotations for `boto3.client("waf-regional")`.

```python
import boto3

from mypy_boto3_waf_regional import WAFRegionalClient

client: WAFRegionalClient = boto3.client("waf-regional")

# now client usage is checked by mypy and IDE should provide code auto-complete

# works for session as well
session = boto3.session.Session(region="us-west-1")
session_client: WAFRegionalClient = session.client("waf-regional")
```

<a id="literals"></a>

### Literals

`mypy_boto3_waf_regional.literals` module contains literals extracted from
shapes that can be used in user code for type checking.

```python
from mypy_boto3_waf_regional.literals import (
    ChangeActionType,
    ChangeTokenStatusType,
    ComparisonOperatorType,
    GeoMatchConstraintTypeType,
    GeoMatchConstraintValueType,
    IPSetDescriptorTypeType,
    MatchFieldTypeType,
    PositionalConstraintType,
    PredicateTypeType,
    RateKeyType,
    ResourceTypeType,
    TextTransformationType,
    WafActionTypeType,
    WafOverrideActionTypeType,
    WafRuleTypeType,
)

def check_value(value: ChangeActionType) -> bool:
    ...
```

<a id="typed-dictionaries"></a>

### Typed dictionaries

`mypy_boto3_waf_regional.type_defs` module contains structures and shapes
assembled to typed dictionaries for additional type checking.

```python
from mypy_boto3_waf_regional.type_defs import (
    ActivatedRuleTypeDef,
    AssociateWebACLRequestTypeDef,
    ByteMatchSetSummaryTypeDef,
    ByteMatchSetTypeDef,
    ByteMatchSetUpdateTypeDef,
    ByteMatchTupleTypeDef,
    CreateByteMatchSetRequestTypeDef,
    CreateByteMatchSetResponseResponseTypeDef,
    CreateGeoMatchSetRequestTypeDef,
    CreateGeoMatchSetResponseResponseTypeDef,
    CreateIPSetRequestTypeDef,
    CreateIPSetResponseResponseTypeDef,
    CreateRateBasedRuleRequestTypeDef,
    CreateRateBasedRuleResponseResponseTypeDef,
    CreateRegexMatchSetRequestTypeDef,
    CreateRegexMatchSetResponseResponseTypeDef,
    CreateRegexPatternSetRequestTypeDef,
    CreateRegexPatternSetResponseResponseTypeDef,
    CreateRuleGroupRequestTypeDef,
    CreateRuleGroupResponseResponseTypeDef,
    CreateRuleRequestTypeDef,
    CreateRuleResponseResponseTypeDef,
    CreateSizeConstraintSetRequestTypeDef,
    CreateSizeConstraintSetResponseResponseTypeDef,
    CreateSqlInjectionMatchSetRequestTypeDef,
    CreateSqlInjectionMatchSetResponseResponseTypeDef,
    CreateWebACLMigrationStackRequestTypeDef,
    CreateWebACLMigrationStackResponseResponseTypeDef,
    CreateWebACLRequestTypeDef,
    CreateWebACLResponseResponseTypeDef,
    CreateXssMatchSetRequestTypeDef,
    CreateXssMatchSetResponseResponseTypeDef,
    DeleteByteMatchSetRequestTypeDef,
    DeleteByteMatchSetResponseResponseTypeDef,
    DeleteGeoMatchSetRequestTypeDef,
    DeleteGeoMatchSetResponseResponseTypeDef,
    DeleteIPSetRequestTypeDef,
    DeleteIPSetResponseResponseTypeDef,
    DeleteLoggingConfigurationRequestTypeDef,
    DeletePermissionPolicyRequestTypeDef,
    DeleteRateBasedRuleRequestTypeDef,
    DeleteRateBasedRuleResponseResponseTypeDef,
    DeleteRegexMatchSetRequestTypeDef,
    DeleteRegexMatchSetResponseResponseTypeDef,
    DeleteRegexPatternSetRequestTypeDef,
    DeleteRegexPatternSetResponseResponseTypeDef,
    DeleteRuleGroupRequestTypeDef,
    DeleteRuleGroupResponseResponseTypeDef,
    DeleteRuleRequestTypeDef,
    DeleteRuleResponseResponseTypeDef,
    DeleteSizeConstraintSetRequestTypeDef,
    DeleteSizeConstraintSetResponseResponseTypeDef,
    DeleteSqlInjectionMatchSetRequestTypeDef,
    DeleteSqlInjectionMatchSetResponseResponseTypeDef,
    DeleteWebACLRequestTypeDef,
    DeleteWebACLResponseResponseTypeDef,
    DeleteXssMatchSetRequestTypeDef,
    DeleteXssMatchSetResponseResponseTypeDef,
    DisassociateWebACLRequestTypeDef,
    ExcludedRuleTypeDef,
    FieldToMatchTypeDef,
    GeoMatchConstraintTypeDef,
    GeoMatchSetSummaryTypeDef,
    GeoMatchSetTypeDef,
    GeoMatchSetUpdateTypeDef,
    GetByteMatchSetRequestTypeDef,
    GetByteMatchSetResponseResponseTypeDef,
    GetChangeTokenResponseResponseTypeDef,
    GetChangeTokenStatusRequestTypeDef,
    GetChangeTokenStatusResponseResponseTypeDef,
    GetGeoMatchSetRequestTypeDef,
    GetGeoMatchSetResponseResponseTypeDef,
    GetIPSetRequestTypeDef,
    GetIPSetResponseResponseTypeDef,
    GetLoggingConfigurationRequestTypeDef,
    GetLoggingConfigurationResponseResponseTypeDef,
    GetPermissionPolicyRequestTypeDef,
    GetPermissionPolicyResponseResponseTypeDef,
    GetRateBasedRuleManagedKeysRequestTypeDef,
    GetRateBasedRuleManagedKeysResponseResponseTypeDef,
    GetRateBasedRuleRequestTypeDef,
    GetRateBasedRuleResponseResponseTypeDef,
    GetRegexMatchSetRequestTypeDef,
    GetRegexMatchSetResponseResponseTypeDef,
    GetRegexPatternSetRequestTypeDef,
    GetRegexPatternSetResponseResponseTypeDef,
    GetRuleGroupRequestTypeDef,
    GetRuleGroupResponseResponseTypeDef,
    GetRuleRequestTypeDef,
    GetRuleResponseResponseTypeDef,
    GetSampledRequestsRequestTypeDef,
    GetSampledRequestsResponseResponseTypeDef,
    GetSizeConstraintSetRequestTypeDef,
    GetSizeConstraintSetResponseResponseTypeDef,
    GetSqlInjectionMatchSetRequestTypeDef,
    GetSqlInjectionMatchSetResponseResponseTypeDef,
    GetWebACLForResourceRequestTypeDef,
    GetWebACLForResourceResponseResponseTypeDef,
    GetWebACLRequestTypeDef,
    GetWebACLResponseResponseTypeDef,
    GetXssMatchSetRequestTypeDef,
    GetXssMatchSetResponseResponseTypeDef,
    HTTPHeaderTypeDef,
    HTTPRequestTypeDef,
    IPSetDescriptorTypeDef,
    IPSetSummaryTypeDef,
    IPSetTypeDef,
    IPSetUpdateTypeDef,
    ListActivatedRulesInRuleGroupRequestTypeDef,
    ListActivatedRulesInRuleGroupResponseResponseTypeDef,
    ListByteMatchSetsRequestTypeDef,
    ListByteMatchSetsResponseResponseTypeDef,
    ListGeoMatchSetsRequestTypeDef,
    ListGeoMatchSetsResponseResponseTypeDef,
    ListIPSetsRequestTypeDef,
    ListIPSetsResponseResponseTypeDef,
    ListLoggingConfigurationsRequestTypeDef,
    ListLoggingConfigurationsResponseResponseTypeDef,
    ListRateBasedRulesRequestTypeDef,
    ListRateBasedRulesResponseResponseTypeDef,
    ListRegexMatchSetsRequestTypeDef,
    ListRegexMatchSetsResponseResponseTypeDef,
    ListRegexPatternSetsRequestTypeDef,
    ListRegexPatternSetsResponseResponseTypeDef,
    ListResourcesForWebACLRequestTypeDef,
    ListResourcesForWebACLResponseResponseTypeDef,
    ListRuleGroupsRequestTypeDef,
    ListRuleGroupsResponseResponseTypeDef,
    ListRulesRequestTypeDef,
    ListRulesResponseResponseTypeDef,
    ListSizeConstraintSetsRequestTypeDef,
    ListSizeConstraintSetsResponseResponseTypeDef,
    ListSqlInjectionMatchSetsRequestTypeDef,
    ListSqlInjectionMatchSetsResponseResponseTypeDef,
    ListSubscribedRuleGroupsRequestTypeDef,
    ListSubscribedRuleGroupsResponseResponseTypeDef,
    ListTagsForResourceRequestTypeDef,
    ListTagsForResourceResponseResponseTypeDef,
    ListWebACLsRequestTypeDef,
    ListWebACLsResponseResponseTypeDef,
    ListXssMatchSetsRequestTypeDef,
    ListXssMatchSetsResponseResponseTypeDef,
    LoggingConfigurationTypeDef,
    PredicateTypeDef,
    PutLoggingConfigurationRequestTypeDef,
    PutLoggingConfigurationResponseResponseTypeDef,
    PutPermissionPolicyRequestTypeDef,
    RateBasedRuleTypeDef,
    RegexMatchSetSummaryTypeDef,
    RegexMatchSetTypeDef,
    RegexMatchSetUpdateTypeDef,
    RegexMatchTupleTypeDef,
    RegexPatternSetSummaryTypeDef,
    RegexPatternSetTypeDef,
    RegexPatternSetUpdateTypeDef,
    ResponseMetadataTypeDef,
    RuleGroupSummaryTypeDef,
    RuleGroupTypeDef,
    RuleGroupUpdateTypeDef,
    RuleSummaryTypeDef,
    RuleTypeDef,
    RuleUpdateTypeDef,
    SampledHTTPRequestTypeDef,
    SizeConstraintSetSummaryTypeDef,
    SizeConstraintSetTypeDef,
    SizeConstraintSetUpdateTypeDef,
    SizeConstraintTypeDef,
    SqlInjectionMatchSetSummaryTypeDef,
    SqlInjectionMatchSetTypeDef,
    SqlInjectionMatchSetUpdateTypeDef,
    SqlInjectionMatchTupleTypeDef,
    SubscribedRuleGroupSummaryTypeDef,
    TagInfoForResourceTypeDef,
    TagResourceRequestTypeDef,
    TagTypeDef,
    TimeWindowTypeDef,
    UntagResourceRequestTypeDef,
    UpdateByteMatchSetRequestTypeDef,
    UpdateByteMatchSetResponseResponseTypeDef,
    UpdateGeoMatchSetRequestTypeDef,
    UpdateGeoMatchSetResponseResponseTypeDef,
    UpdateIPSetRequestTypeDef,
    UpdateIPSetResponseResponseTypeDef,
    UpdateRateBasedRuleRequestTypeDef,
    UpdateRateBasedRuleResponseResponseTypeDef,
    UpdateRegexMatchSetRequestTypeDef,
    UpdateRegexMatchSetResponseResponseTypeDef,
    UpdateRegexPatternSetRequestTypeDef,
    UpdateRegexPatternSetResponseResponseTypeDef,
    UpdateRuleGroupRequestTypeDef,
    UpdateRuleGroupResponseResponseTypeDef,
    UpdateRuleRequestTypeDef,
    UpdateRuleResponseResponseTypeDef,
    UpdateSizeConstraintSetRequestTypeDef,
    UpdateSizeConstraintSetResponseResponseTypeDef,
    UpdateSqlInjectionMatchSetRequestTypeDef,
    UpdateSqlInjectionMatchSetResponseResponseTypeDef,
    UpdateWebACLRequestTypeDef,
    UpdateWebACLResponseResponseTypeDef,
    UpdateXssMatchSetRequestTypeDef,
    UpdateXssMatchSetResponseResponseTypeDef,
    WafActionTypeDef,
    WafOverrideActionTypeDef,
    WebACLSummaryTypeDef,
    WebACLTypeDef,
    WebACLUpdateTypeDef,
    XssMatchSetSummaryTypeDef,
    XssMatchSetTypeDef,
    XssMatchSetUpdateTypeDef,
    XssMatchTupleTypeDef,
)

def get_structure() -> ActivatedRuleTypeDef:
    return {
      ...
    }
```

<a id="versioning"></a>

## Versioning

`mypy-boto3-waf-regional` version is the same as related `boto3` version and
follows [PEP 440](https://www.python.org/dev/peps/pep-0440/) format.

<a id="documentation"></a>

## Documentation

All type annotations can be found in
[mypy-boto3-waf-regional docs](https://vemel.github.io/boto3_stubs_docs/mypy_boto3_waf_regional/)

<a id="support-and-contributing"></a>

## Support and contributing

This package is auto-generated. Please reports any bugs or request new features
in [mypy-boto3-builder](https://github.com/vemel/mypy_boto3_builder/issues/)
repository.
